Index: src/builder.cpp
===================================================================
--- src/builder.cpp	(revision d8b94a86944c4679c88bc250bff510f242d63309)
+++ src/builder.cpp	(revision 1907a789609146bbdebfeff09de44cb4ba21b808)
@@ -617,14 +620,444 @@
 };
 
+/********************************************** Submenu routine **************************************/
+
+/** Submenu for manipulating atoms.
+ * \param *periode periodentafel
+ * \param *molecules list of molecules whose atoms are to be manipulated
+ */
+static void ManipulateAtoms(periodentafel *periode, MoleculeListClass *molecules, config *configuration)
+{
+  atom *first, *second, *third, *fourth;
+  Vector **atoms;
+  molecule *mol = NULL;
+  Vector x,y,z,n; // coordinates for absolute point in cell volume
+  double *factor; // unit factor if desired
+  double a,b,c;
+  double bond, min_bond;
+  char choice;  // menu choice char
+  bool valid;
+
+  cout << Verbose(0) << "=========MANIPULATE ATOMS======================" << endl;
+  cout << Verbose(0) << "a - add an atom" << endl;
+  cout << Verbose(0) << "r - remove an atom" << endl;
+  cout << Verbose(0) << "b - scale a bond between atoms" << endl;
+  cout << Verbose(0) << "u - change an atoms element" << endl;
+  cout << Verbose(0) << "l - measure lengths, angles, ... for an atom" << endl;
+  cout << Verbose(0) << "all else - go back" << endl;
+  cout << Verbose(0) << "===============================================" << endl;
+  if (molecules->NumberOfActiveMolecules() > 0)
+    cout << Verbose(0) << "WARNING: There is more than one molecule active! Atoms will be added to each." << endl;
+  cout << Verbose(0) << "INPUT: ";
+  cin >> choice;
+
+  switch (choice) {
+    default:
+      cout << Verbose(0) << "Not a valid choice." << endl;
+      break;
+
+    case 'a': // add atom
+      for (MoleculeList::iterator ListRunner = molecules->ListOfMolecules.begin(); ListRunner != molecules->ListOfMolecules.end(); ListRunner++) {
+        mol = *ListRunner;
+        cout << Verbose(0) << "Current molecule is: " << mol->IndexNr << "\t" << mol->name << endl;
+        AddAtoms(periode, mol);
+      }
+      break;
+
+    case 'b': // scale a bond
+      for (MoleculeList::iterator ListRunner = molecules->ListOfMolecules.begin(); ListRunner != molecules->ListOfMolecules.end(); ListRunner++) {
+        mol = *ListRunner;
+        cout << Verbose(0) << "Current molecule is: " << mol->IndexNr << "\t" << mol->name << endl;
+        cout << Verbose(0) << "Scaling bond length between two atoms." << endl;
+        first = mol->AskAtom("Enter first (fixed) atom: ");
+        second = mol->AskAtom("Enter second (shifting) atom: ");
+        min_bond = 0.;
+        for (int i=NDIM;i--;)
+          min_bond += (first->x.x[i]-second->x.x[i])*(first->x.x[i] - second->x.x[i]);
+        min_bond = sqrt(min_bond);
+        cout << Verbose(0) << "Current Bond length between " << first->type->name << " Atom " << first->nr << " and " << second->type->name << " Atom " << second->nr << ": " << min_bond << " a.u." << endl;
+        cout << Verbose(0) << "Enter new bond length [a.u.]: ";
+        cin >> bond;
+        for (int i=NDIM;i--;) {
+          second->x.x[i] -= (second->x.x[i]-first->x.x[i])/min_bond*(min_bond-bond);
+        }
+        //cout << Verbose(0) << "New coordinates of Atom " << second->nr << " are: ";
+        //second->Output(second->type->No, 1, (ofstream *)&cout);
+      }
+      break;
+
+    case 'c': // unit scaling of the metric
+      for (MoleculeList::iterator ListRunner = molecules->ListOfMolecules.begin(); ListRunner != molecules->ListOfMolecules.end(); ListRunner++) {
+        mol = *ListRunner;
+        cout << Verbose(0) << "Current molecule is: " << mol->IndexNr << "\t" << mol->name << endl;
+       cout << Verbose(0) << "Angstroem -> Bohrradius: 1.8897261\t\tBohrradius -> Angstroem: 0.52917721" << endl;
+       cout << Verbose(0) << "Enter three factors: ";
+       factor = new double[NDIM];
+       cin >> factor[0];
+       cin >> factor[1];
+       cin >> factor[2];
+       valid = true;
+       mol->Scale(&factor);
+       delete[](factor);
+      }
+     break;
+
+    case 'l': // measure distances or angles
+      for (MoleculeList::iterator ListRunner = molecules->ListOfMolecules.begin(); ListRunner != molecules->ListOfMolecules.end(); ListRunner++) {
+        mol = *ListRunner;
+        cout << Verbose(0) << "Current molecule is: " << mol->IndexNr << "\t" << mol->name << endl;
+        MeasureAtoms(periode, mol, configuration);
+      }
+      break;
+
+    case 'r': // remove atom
+      for (MoleculeList::iterator ListRunner = molecules->ListOfMolecules.begin(); ListRunner != molecules->ListOfMolecules.end(); ListRunner++) {
+        mol = *ListRunner;
+        cout << Verbose(0) << "Current molecule is: " << mol->IndexNr << "\t" << mol->name << endl;
+        RemoveAtoms(mol);
+      }
+      break;
+
+    case 'u': // change an atom's element
+      for (MoleculeList::iterator ListRunner = molecules->ListOfMolecules.begin(); ListRunner != molecules->ListOfMolecules.end(); ListRunner++) {
+        int Z;
+        mol = *ListRunner;
+        cout << Verbose(0) << "Current molecule is: " << mol->IndexNr << "\t" << mol->name << endl;
+        first = NULL;
+        do {
+          cout << Verbose(0) << "Change the element of which atom: ";
+          cin >> Z;
+        } while ((first = mol->FindAtom(Z)) == NULL);
+        cout << Verbose(0) << "New element by atomic number Z: ";
+        cin >> Z;
+        first->type = periode->FindElement(Z);
+        cout << Verbose(0) << "Atom " << first->nr << "'s element is " << first->type->name << "." << endl;
+      }
+      break;
+  }
+};
+
+/** Submenu for manipulating molecules.
+ * \param *periode periodentafel
+ * \param *molecules list of molecule to manipulate
+ */
+static void ManipulateMolecules(periodentafel *periode, MoleculeListClass *molecules, config *configuration)
+{
+  atom *first, *second, *third, *fourth;
+  Vector **atoms;
+  Vector x,y,z,n; // coordinates for absolute point in cell volume
+  double a,b,c;
+  int j, axis, count, faktor;
+  char choice;  // menu choice char
+  bool valid;
+  molecule *mol = NULL;
+  element **Elements;
+  Vector **vectors;
+  MoleculeLeafClass *Subgraphs = NULL;
+
+  cout << Verbose(0) << "=========MANIPULATE GLOBALLY===================" << endl;
+  cout << Verbose(0) << "c - scale by unit transformation" << endl;
+  cout << Verbose(0) << "d - duplicate molecule/periodic cell" << endl;
+  cout << Verbose(0) << "f - fragment molecule many-body bond order style" << endl;
+  cout << Verbose(0) << "g - center atoms in box" << endl;
+  cout << Verbose(0) << "i - realign molecule" << endl;
+  cout << Verbose(0) << "m - mirror all molecules" << endl;
+  cout << Verbose(0) << "o - create connection matrix" << endl;
+  cout << Verbose(0) << "t - translate molecule by vector" << endl;
+  cout << Verbose(0) << "all else - go back" << endl;
+  cout << Verbose(0) << "===============================================" << endl;
+  if (molecules->NumberOfActiveMolecules() > 0)
+    cout << Verbose(0) << "WARNING: There is more than one molecule active! Atoms will be added to each." << endl;
+  cout << Verbose(0) << "INPUT: ";
+  cin >> choice;
+
+  switch (choice) {
+    default:
+      cout << Verbose(0) << "Not a valid choice." << endl;
+      break;
+
+    case 'd': // duplicate the periodic cell along a given axis, given times
+      for (MoleculeList::iterator ListRunner = molecules->ListOfMolecules.begin(); ListRunner != molecules->ListOfMolecules.end(); ListRunner++) {
+        mol = *ListRunner;
+        cout << Verbose(0) << "Current molecule is: " << mol->IndexNr << "\t" << mol->name << endl;
+        cout << Verbose(0) << "State the axis [(+-)123]: ";
+        cin >> axis;
+        cout << Verbose(0) << "State the factor: ";
+        cin >> faktor;
+
+        mol->CountAtoms((ofstream *)&cout); // recount atoms
+        if (mol->AtomCount != 0) {  // if there is more than none
+          count = mol->AtomCount;  // is changed becausing of adding, thus has to be stored away beforehand
+          Elements = new element *[count];
+          vectors = new Vector *[count];
+          j = 0;
+          first = mol->start;
+          while (first->next != mol->end) { // make a list of all atoms with coordinates and element
+            first = first->next;
+            Elements[j] = first->type;
+            vectors[j] = &first->x;
+            j++;
+          }
+          if (count != j)
+            cout << Verbose(0) << "ERROR: AtomCount " << count << " is not equal to number of atoms in molecule " << j << "!" << endl;
+          x.Zero();
+          y.Zero();
+          y.x[abs(axis)-1] = mol->cell_size[(abs(axis) == 2) ? 2 : ((abs(axis) == 3) ? 5 : 0)] * abs(axis)/axis; // last term is for sign, first is for magnitude
+          for (int i=1;i<faktor;i++) {  // then add this list with respective translation factor times
+            x.AddVector(&y); // per factor one cell width further
+            for (int k=count;k--;) { // go through every atom of the original cell
+              first = new atom(); // create a new body
+              first->x.CopyVector(vectors[k]);  // use coordinate of original atom
+              first->x.AddVector(&x);     // translate the coordinates
+              first->type = Elements[k];  // insert original element
+              mol->AddAtom(first);        // and add to the molecule (which increments ElementsInMolecule, AtomCount, ...)
+            }
+          }
+          if (mol->first->next != mol->last) // if connect matrix is present already, redo it
+            mol->CreateAdjacencyList((ofstream *)&cout, mol->BondDistance, configuration->GetIsAngstroem());
+          // free memory
+          delete[](Elements);
+          delete[](vectors);
+          // correct cell size
+          if (axis < 0) { // if sign was negative, we have to translate everything
+            x.Zero();
+            x.AddVector(&y);
+            x.Scale(-(faktor-1));
+            mol->Translate(&x);
+          }
+          mol->cell_size[(abs(axis) == 2) ? 2 : ((abs(axis) == 3) ? 5 : 0)] *= faktor;
+        }
+      }
+      break;
+
+    case 'f':
+      FragmentAtoms(mol, configuration);
+      break;
+
+    case 'g': // center the atoms
+      for (MoleculeList::iterator ListRunner = molecules->ListOfMolecules.begin(); ListRunner != molecules->ListOfMolecules.end(); ListRunner++) {
+        mol = *ListRunner;
+        cout << Verbose(0) << "Current molecule is: " << mol->IndexNr << "\t" << mol->name << endl;
+        CenterAtoms(mol);
+      }
+      break;
+
+    case 'i': // align all atoms
+      for (MoleculeList::iterator ListRunner = molecules->ListOfMolecules.begin(); ListRunner != molecules->ListOfMolecules.end(); ListRunner++) {
+        mol = *ListRunner;
+        cout << Verbose(0) << "Current molecule is: " << mol->IndexNr << "\t" << mol->name << endl;
+        AlignAtoms(periode, mol);
+      }
+      break;
+
+    case 'm': // mirror atoms along a given axis
+      for (MoleculeList::iterator ListRunner = molecules->ListOfMolecules.begin(); ListRunner != molecules->ListOfMolecules.end(); ListRunner++) {
+        mol = *ListRunner;
+        cout << Verbose(0) << "Current molecule is: " << mol->IndexNr << "\t" << mol->name << endl;
+        MirrorAtoms(mol);
+      }
+      break;
+
+    case 'o': // create the connection matrix
+      {
+        double bonddistance;
+        clock_t start,end;
+        cout << Verbose(0) << "What's the maximum bond distance: ";
+        cin >> bonddistance;
+        start = clock();
+        mol->CreateAdjacencyList((ofstream *)&cout, bonddistance, configuration->GetIsAngstroem());
+        mol->CreateListOfBondsPerAtom((ofstream *)&cout);
+        end = clock();
+        cout << Verbose(0) << "Clocks for this operation: " << (end-start) << ", time: " << ((double)(end-start)/CLOCKS_PER_SEC) << "s." << endl;
+      }
+      break;
+
+    case 't': // translate all atoms
+     for (MoleculeList::iterator ListRunner = molecules->ListOfMolecules.begin(); ListRunner != molecules->ListOfMolecules.end(); ListRunner++) {
+        mol = *ListRunner;
+        cout << Verbose(0) << "Current molecule is: " << mol->IndexNr << "\t" << mol->name << endl;
+        cout << Verbose(0) << "Enter translation vector." << endl;
+        x.AskPosition(mol->cell_size,0);
+        mol->Translate((const Vector *)&x);
+     }
+     break;
+  }
+  // Free all
+  if (Subgraphs != NULL) {  // free disconnected subgraph list of DFS analysis was performed
+    while (Subgraphs->next != NULL) {
+      Subgraphs = Subgraphs->next;
+      delete(Subgraphs->previous);
+    }
+    delete(Subgraphs);
+  }
+};
+
+
+/** Submenu for creating new molecules.
+ * \param *periode periodentafel
+ * \param *molecules list of molecules to add to
+ */
+static void EditMolecules(periodentafel *periode, MoleculeListClass *molecules)
+{
+  char choice;  // menu choice char
+  bool valid;
+  Vector Center;
+  int nr, count;
+  molecule *mol = NULL;
+  char *molname = NULL;
+  int length;
+  char filename[MAXSTRINGSIZE];
+
+  cout << Verbose(0) << "==========Edit MOLECULES=====================" << endl;
+  cout << Verbose(0) << "c - create new molecule" << endl;
+  cout << Verbose(0) << "l - load molecule from xyz file" << endl;
+  cout << Verbose(0) << "n - change molecule's name" << endl;
+  cout << Verbose(0) << "N - give molecules filename" << endl;
+  cout << Verbose(0) << "p - parse xyz file into molecule" << endl;
+  cout << Verbose(0) << "r - remove a molecule" << endl;
+  cout << Verbose(0) << "all else - go back" << endl;
+  cout << Verbose(0) << "===============================================" << endl;
+  cout << Verbose(0) << "INPUT: ";
+  cin >> choice;
+
+  switch (choice) {
+    default:
+      cout << Verbose(0) << "Not a valid choice." << endl;
+      break;
+    case 'c':
+      mol = new molecule(periode);
+      molecules->insert(mol);
+      break;
+
+    case 'l': // laod from XYZ file
+      cout << Verbose(0) << "Format should be XYZ with: ShorthandOfElement\tX\tY\tZ" << endl;
+      mol = new molecule(periode);
+      do {
+        cout << Verbose(0) << "Enter file name: ";
+        cin >> filename;
+      } while (!mol->AddXYZFile(filename));
+      mol->SetNameFromFilename(filename);
+      // center at set box dimensions
+      mol->CenterEdge((ofstream *)&cout, &Center);
+      mol->cell_size[0] = Center.x[0];
+      mol->cell_size[1] = 0;
+      mol->cell_size[2] = Center.x[1];
+      mol->cell_size[3] = 0;
+      mol->cell_size[4] = 0;
+      mol->cell_size[5] = Center.x[2];
+      molecules->insert(mol);
+      break;
+
+    case 'n':
+      do {
+        cout << Verbose(0) << "Enter index of molecule: ";
+        cin >> nr;
+        mol = molecules->ReturnIndex(nr);
+      } while (mol != NULL);
+      cout << Verbose(0) << "Enter name: ";
+      cin >> filename;
+      strcpy(mol->name, filename);
+      break;
+
+    case 'N':
+      do {
+        cout << Verbose(0) << "Enter index of molecule: ";
+        cin >> nr;
+        mol = molecules->ReturnIndex(nr);
+      } while (mol != NULL);
+      cout << Verbose(0) << "Enter name: ";
+      cin >> filename;
+      mol->SetNameFromFilename(filename);
+      break;
+
+    case 'p': // parse XYZ file
+      mol = NULL;
+      do {
+        cout << Verbose(0) << "Enter index of molecule: ";
+        cin >> nr;
+        mol = molecules->ReturnIndex(nr);
+      } while (mol == NULL);
+      cout << Verbose(0) << "Format should be XYZ with: ShorthandOfElement\tX\tY\tZ" << endl;
+      do {
+        cout << Verbose(0) << "Enter file name: ";
+        cin >> filename;
+      } while (!mol->AddXYZFile(filename));
+      mol->SetNameFromFilename(filename);
+      break;
+
+    case 'r':
+      cout << Verbose(0) << "Enter index of molecule: ";
+      cin >> nr;
+      count = 1;
+      MoleculeList::iterator ListRunner = molecules->ListOfMolecules.begin();
+      for(; ((ListRunner != molecules->ListOfMolecules.end()) && (count < nr)); ListRunner++);
+      mol = *ListRunner;
+      if (count == nr) {
+        molecules->ListOfMolecules.erase(ListRunner);
+        delete(mol);
+      }
+      break;
+  }
+};
+
+
+/** Submenu for merging molecules.
+ * \param *periode periodentafel
+ * \param *molecules list of molecules to add to
+ */
+static void MergeMolecules(periodentafel *periode, MoleculeListClass *molecules)
+{
+  char choice;  // menu choice char
+  bool valid;
+
+  cout << Verbose(0) << "===========MERGE MOLECULES=====================" << endl;
+  cout << Verbose(0) << "e - embedding merge of two molecules" << endl;
+  cout << Verbose(0) << "m - multi-merge of all molecules" << endl;
+  cout << Verbose(0) << "s - scatter merge of two molecules" << endl;
+  cout << Verbose(0) << "t - simple merge of two molecules" << endl;
+  cout << Verbose(0) << "all else - go back" << endl;
+  cout << Verbose(0) << "===============================================" << endl;
+  cout << Verbose(0) << "INPUT: ";
+  cin >> choice;
+
+  switch (choice) {
+    default:
+      cout << Verbose(0) << "Not a valid choice." << endl;
+      break;
+
+    case 'e':
+      break;
+
+    case 'm':
+      break;
+
+    case 's':
+      break;
+
+    case 't':
+      break;
+  }
+};
+
+
 /********************************************** Test routine **************************************/
 
 /** Is called always as option 'T' in the menu.
+ * \param *molecules list of molecules
  */
-static void testroutine(molecule *mol)
+static void testroutine(MoleculeListClass *molecules)
 {
 	// the current test routine checks the functionality of the KeySet&Graph concept:
 	// We want to have a multiindex (the KeySet) describing a unique subgraph
-	atom *Walker = mol->start;
-	int i, comp, counter=0;
+  int i, comp, counter=0;
+
+  // create a clone
+  molecule *mol = NULL;
+  if (molecules->ListOfMolecules.size() != 0) // clone
+    mol = (molecules->ListOfMolecules.front())->CopyMolecule();
+  else {
+    cerr << "I don't have anything to test on ... ";
+    return;
+  }
+  atom *Walker = mol->start;
 
 	// generate some KeySets
@@ -686,4 +1119,5 @@
 		A++;
 	}
+	delete(mol);
 };
 
@@ -692,10 +1126,19 @@
  * \param *configuration pointer to configuration structure with all the values
  * \param *periode pointer to periodentafel structure with all the elements
- * \param *mol pointer to molecule structure with all the atoms and coordinates
+ * \param *molecules list of molecules structure with all the atoms and coordinates
  */
-static void SaveConfig(char *ConfigFileName, config *configuration, periodentafel *periode, molecule *mol)
+static void SaveConfig(char *ConfigFileName, config *configuration, periodentafel *periode, MoleculeListClass *molecules)
 {
 	char filename[MAXSTRINGSIZE];
 	ofstream output;
+	molecule *mol = new molecule(periode);
+
+	// merge all molecules in MoleculeListClass into this molecule
+	int N = molecules->ListOfMolecules.size();
+	int *src = new int(N);
+	N=0;
+	for (MoleculeList::iterator ListRunner = molecules->ListOfMolecules.begin(); ListRunner != molecules->ListOfMolecules.end(); ListRunner++)
+	  src[N++] = (*ListRunner)->IndexNr;
+	molecules->SimpleMultiAdd(mol, src, N);
 
 	cout << Verbose(0) << "Storing configuration ... " << endl;
@@ -761,4 +1204,5 @@
 		cerr << "WARNING: config is found under different path then stated in config file::defaultpath!" << endl;
 	}
+	delete(mol);
 };
 
@@ -766,5 +1210,5 @@
  * \param argc argument count
  * \param **argv arguments array
- * \param *mol molecule structure
+ * \param *molecules list of molecules structure
  * \param *periode elements structure
  * \param configuration config file structure
@@ -773,5 +1217,5 @@
  * \return exit code (0 - successful, all else - something's wrong)
  */
-static int ParseCommandLineOptions(int argc, char **argv, molecule *&mol, periodentafel *&periode, config& configuration, char *&ConfigFileName, char *&PathToDatabases)
+static int ParseCommandLineOptions(int argc, char **argv, MoleculeListClass *&molecules, periodentafel *&periode, config& configuration, char *&ConfigFileName, char *&PathToDatabases)
 {
 	Vector x,y,z,n;	// coordinates for absolute point in cell volume
@@ -789,4 +1233,8 @@
 	int argptr;
 	PathToDatabases = LocalPath;
+
+	// simply create a new molecule, wherein the config file is loaded and the manipulation takes place
+	molecule *mol = new molecule(periode);
+	molecules->insert(mol);
 
 	if (argc > 1) { // config file specified as option
@@ -1327,5 +1775,5 @@
 		} while (argptr < argc);
 		if (SaveFlag)
-			SaveConfig(ConfigFileName, &configuration, periode, mol);
+			SaveConfig(ConfigFileName, &configuration, periode, molecules);
 		if ((ExitFlag >= 1)) {
 			delete(mol);
@@ -1348,40 +1796,36 @@
 {
 	periodentafel *periode = new periodentafel; // and a period table of all elements
-	molecule *mol = new molecule(periode);		// first we need an empty molecule
+	MoleculeListClass *molecules = new MoleculeListClass;  // list of all molecules
+	molecule *mol = NULL;
 	config configuration;
 	double tmp1;
-	double bond, min_bond;
 	atom *first, *second;
 	char choice;	// menu choice char
 	Vector x,y,z,n;	// coordinates for absolute point in cell volume
-	double *factor;	// unit factor if desired
 	bool valid; // flag if input was valid or not
 	ifstream test;
 	ofstream output;
 	string line;
-	char filename[MAXSTRINGSIZE];
 	char *ConfigFileName = NULL;
 	char *ElementsFileName = NULL;
 	int Z;
 	int j, axis, count, faktor;
-	clock_t start,end;
-//	int *MinimumRingSize = NULL;
-	MoleculeLeafClass *Subgraphs = NULL;
-//	class StackClass<bond *> *BackEdgeStack = NULL;
-	element **Elements;
-	Vector **vectors;
 
 	// =========================== PARSE COMMAND LINE OPTIONS ====================================
-	j = ParseCommandLineOptions(argc, argv, mol, periode, configuration, ConfigFileName, ElementsFileName);
+	j = ParseCommandLineOptions(argc, argv, molecules, periode, configuration, ConfigFileName, ElementsFileName);
 	if (j == 1) return 0; // just for -v and -h options
 	if (j) return j;	// something went wrong
 
 	// General stuff
-	if (mol->cell_size[0] == 0.) {
-		cout << Verbose(0) << "enter lower triadiagonal form of basis matrix" << endl << endl;
-		for (int i=0;i<6;i++) {
-			cout << Verbose(1) << "Cell size" << i << ": ";
-			cin >> mol->cell_size[i];
-		}
+	if (molecules->ListOfMolecules.size() == 0) {
+    mol = new molecule(periode);
+    if (mol->cell_size[0] == 0.) {
+      cout << Verbose(0) << "enter lower tridiagonal form of basis matrix" << endl << endl;
+      for (int i=0;i<6;i++) {
+        cout << Verbose(1) << "Cell size" << i << ": ";
+        cin >> mol->cell_size[i];
+      }
+    }
+    molecules->insert(mol);
 	}
 
